#!/usr/bin/env python
#
# controlServo.py
#
# controlServo.py (serial_port port_speed)
#
# Neil Gershenfeld
# CBA MIT 7/27/07
#
# (c) Massachusetts Institute of Technology 2007
# Permission granted for experimental and personal use;
# license for commercial sale available from MIT.
#

import sys,time,serial
from Tkinter import *
from select import *

# set to true to have port and speed specified on the commandline
want_commandline_args=False

PORT = "/dev/ttyACM0"
#PORT = "/dev/ttyUSB0"
SPEED = 115200

SCALE_FROM = 0
SCALE_TO = 9


def rec_value():
   #for i in (range(1,30)):
   while (ser.inWaiting()):
      byte = ser.read()
      #print "answer from Servo: ",byte
      print byte

def send_value():
   value_int=widget_control.get()
   value_char=str(value_int)
   #uncomment="""
   #"""
   print "sending ",value_char,"to the Servo"
   ser.write(value_char)

def quit():
   #
   # clean up and quit
   #
   sys.exit()

def idle(parent):
   #
   # idle loop
   #
   #uncomment="""
   #wait = ser.inWaiting()
   #if (wait != 0):
      #
      # read character
      #
      #rec_value()
      #send_value()
   #"""
   rec_value()
   send_value()
   #time.sleep(0.001)
   time.sleep(0.001)
   parent.after_idle(idle,parent)

#
#  check command line arguments
#
if (want_commandline_args):
   if (len(sys.argv) != 3):
      print "command line: term.py serial_port speed"
      sys.exit()
   port = sys.argv[1]
   speed = int(sys.argv[2])
else:
   port = PORT
   speed = SPEED
#
# open serial port
#
#uncomment="""
ser = serial.Serial(PORT,SPEED)
ser.setDTR()
#"""
#
# flush buffers
#
#uncomment="""
ser.flushInput()
ser.flushOutput()
#"""
#
# set up UI
#
root = Tk()
root.title('controlServo.py')
#
widget_quit = Button(root, text="quit",command=quit)
widget_quit.pack()
#
address_frame = Frame(root)
Label(address_frame,text="port: "+port).pack(side='left')
Label(address_frame,text="  speed: "+str(speed)).pack(side='left')
address_frame.pack()
#
widget_control = Scale(root, from_=SCALE_FROM, to=SCALE_TO, orient=HORIZONTAL)
widget_control.set(int((SCALE_TO-SCALE_FROM)/2))
widget_control.pack()
#
# begin event loop
#
root.after(100,idle,root)
root.mainloop()
